OpenTTD: Ship Struct Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
Ship Struct Reference

All ships have this type. More...

`#include <ship.h>`

Inheritance diagram for Ship:

## Public Member Functions
| Ship ()
| We don't want GCC to zero our struct! It already is zeroed and has an index!
virtual | ~Ship ()
| We want to 'destruct' the right class.
void | MarkDirty ()
| Marks the vehicles to be redrawn and updates cached variables.
void | UpdateDeltaXY (Direction direction)
| Updates the x and y offsets and the size of the sprite used for this vehicle.
ExpensesType | GetExpenseType (bool income) const
| Sets the expense type associated to this vehicle type.
void | PlayLeaveStationSound () const
| Play the sound associated with leaving the station.
bool | IsPrimaryVehicle () const
| Whether this is the primary vehicle in the chain.
void | GetImage (Direction direction, EngineImageType image_type, VehicleSpriteSeq *result) const
| Gets the sprite to show for the given direction.
int | GetDisplaySpeed () const
| Gets the speed in km-ish/h that can be sent into SetDParam for string processing.
int | GetDisplayMaxSpeed () const
| Gets the maximum speed in km-ish/h that can be sent into SetDParam for string processing.
int | GetCurrentMaxSpeed () const
| Calculates the maximum speed of the vehicle under its current conditions.
Money | GetRunningCost () const
| Gets the running cost of a vehicle.
bool | IsInDepot () const
| Check whether the vehicle is in the depot.
bool | Tick ()
| Calls the tick handler of the vehicle.
void | OnNewDay ()
| Calls the new day handler of the vehicle.
Trackdir | GetVehicleTrackdir () const
| Returns the Trackdir on which the vehicle is currently located.
TileIndex | GetOrderStationLocation (StationID station)
| Determine the location for the station where the vehicle goes to next.
bool | FindClosestDepot (TileIndex *location, DestinationID *destination, bool *reverse)
| Find the closest depot for this vehicle and tell us the location, DestinationID and whether we should reverse.
void | UpdateCache ()
| Update the caches of this ship.
Public Member Functions inherited from SpecializedVehicle< Ship, VEH_SHIP >
| SpecializedVehicle ()
| Set vehicle type correctly.
Ship * | First () const
| Get the first vehicle in the chain.
Ship * | Last ()
| Get the last vehicle in the chain.
const Ship * | Last () const
| Get the last vehicle in the chain.
Ship * | Next () const
| Get next vehicle in the chain.
Ship * | Previous () const
| Get previous vehicle in the chain.
Ship * | GetNextArticulatedPart ()
| Get the next part of an articulated engine.
Ship * | GetNextArticulatedPart () const
| Get the next part of an articulated engine.
Ship * | GetFirstEnginePart ()
| Get the first part of an articulated engine.
const Ship * | GetFirstEnginePart () const
| Get the first part of an articulated engine.
Ship * | GetLastEnginePart ()
| Get the last part of an articulated engine.
Ship * | GetNextVehicle () const
| Get the next real (non-articulated part) vehicle in the consist.
Ship * | GetPrevVehicle () const
| Get the previous real (non-articulated part) vehicle in the consist.
void | UpdateViewport (bool force_update, bool update_delta)
| Update vehicle sprite- and position caches.
Public Member Functions inherited from Vehicle
| Vehicle (VehicleType type=VEH_INVALID)
| Vehicle constructor.
void | PreDestructor ()
| Destroy all stuff that (still) needs the virtual functions to work properly.
virtual | ~Vehicle ()
| We want to 'destruct' the right class.
void | BeginLoading ()
| Prepare everything to begin the loading when arriving at a station.
void | CancelReservation (StationID next, Station *st)
| Return all reserved cargo packets to the station and reset all packets staged for transfer.
void | LeaveStation ()
| Perform all actions when leaving a station.
GroundVehicleCache * | GetGroundVehicleCache ()
| Access the ground vehicle cache of the vehicle.
const GroundVehicleCache * | GetGroundVehicleCache () const
| Access the ground vehicle cache of the vehicle.
uint16 & | GetGroundVehicleFlags ()
| Access the ground vehicle flags of the vehicle.
const uint16 & | GetGroundVehicleFlags () const
| Access the ground vehicle flags of the vehicle.
void | DeleteUnreachedImplicitOrders ()
| Delete all implicit orders which were not reached.
void | HandleLoading (bool mode=false)
| Handle the loading of the vehicle; when not it skips through dummy orders and does nothing in all other cases.
void | GetConsistFreeCapacities (SmallMap< CargoID, uint > &capacities) const
| Get a map of cargoes and free capacities in the consist.
uint | GetConsistTotalCapacity () const
uint | GetOldAdvanceSpeed (uint speed)
| Determines the effective direction-specific vehicle movement speed.
uint | GetAdvanceDistance ()
| Determines the vehicle "progress" needed for moving a step.
const Engine * | GetEngine () const
| Retrieves the engine of the vehicle.
const GRFFile * | GetGRF () const
| Retrieve the NewGRF the vehicle is tied to.
uint32 | GetGRFID () const
| Retrieve the GRF ID of the NewGRF the vehicle is tied to.
void | InvalidateNewGRFCache ()
| Invalidates cached NewGRF variables.
void | InvalidateNewGRFCacheOfChain ()
| Invalidates cached NewGRF variables of all vehicles in the chain (after the current vehicle)
bool | IsGroundVehicle () const
| Check if the vehicle is a ground vehicle.
virtual bool | IsChainInDepot () const
| Check whether the whole vehicle chain is in the depot.
bool | IsStoppedInDepot () const
| Check whether the vehicle is in the depot and stopped.
virtual uint | Crash (bool flooded=false)
| Crash the (whole) vehicle chain.
Money | GetDisplayRunningCost () const
| Gets the running cost of a vehicle that can be sent into SetDParam for string processing.
Money | GetDisplayProfitThisYear () const
| Gets the profit vehicle had this year.
Money | GetDisplayProfitLastYear () const
| Gets the profit vehicle had last year.
void | SetNext (Vehicle *next)
| Set the next vehicle of this vehicle.
Vehicle * | Move (int n)
| Get the vehicle at offset n of this vehicle chain.
const Vehicle * | Move (int n) const
| Get the vehicle at offset n of this vehicle chain.
Order * | GetFirstOrder () const
| Get the first order of the vehicles order list.
void | AddToShared (Vehicle *shared_chain)
| Adds this vehicle to a shared vehicle chain.
void | RemoveFromShared ()
| Removes the vehicle from the shared order list.
Vehicle * | NextShared () const
| Get the next vehicle of the shared vehicle chain.
Vehicle * | PreviousShared () const
| Get the previous vehicle of the shared vehicle chain.
Vehicle * | FirstShared () const
| Get the first vehicle of this vehicle chain.
bool | IsOrderListShared () const
| Check if we share our orders with another vehicle.
VehicleOrderID | GetNumOrders () const
| Get the number of orders this vehicle has.
VehicleOrderID | GetNumManualOrders () const
| Get the number of manually added orders this vehicle has.
StationIDStack | GetNextStoppingStation () const
| Get the next station the vehicle will stop at.
void | ResetRefitCaps ()
| Reset all refit_cap in the consist to cargo_cap.
void | CopyVehicleConfigAndStatistics (const Vehicle *src)
| Copy certain configurations and statistics of a vehicle after successful autoreplace/renew The function shall copy everything that cannot be copied by a command (like orders / group etc), and that shall not be resetted for the new vehicle.
bool | HandleBreakdown ()
| Handle all of the aspects of a vehicle breakdown This includes adding smoke and sounds, and ending the breakdown when appropriate.
bool | NeedsAutorenewing (const Company *c, bool use_renew_setting=true) const
| Function to tell if a vehicle needs to be autorenewed.
bool | NeedsServicing () const
| Check if the vehicle needs to go to a depot in near future (if a opportunity presents itself) for service or replacement.
bool | NeedsAutomaticServicing () const
| Checks if the current order should be interrupted for a service-in-depot order.
CommandCost | SendToDepot (DoCommandFlag flags, DepotCommand command)
| Send this vehicle to the depot using the given command(s).
void | UpdateVisualEffect (bool allow_power_change=true)
| Update the cached visual effect.
void | ShowVisualEffect () const
| Draw visual effects (smoke and/or sparks) for a vehicle chain.
void | UpdatePosition ()
| Update the position of the vehicle.
void | UpdateViewport (bool dirty)
| Update the vehicle on the viewport, updating the right hash and setting the new coordinates.
void | UpdatePositionAndViewport ()
| Update the position of the vehicle, and update the viewport.
void | MarkAllViewportsDirty () const
| Marks viewports dirty where the vehicle's image is.
uint16 | GetServiceInterval () const
void | SetServiceInterval (uint16 interval)
bool | ServiceIntervalIsCustom () const
bool | ServiceIntervalIsPercent () const
void | SetServiceIntervalIsCustom (bool on)
void | SetServiceIntervalIsPercent (bool on)
void | IncrementImplicitOrderIndex ()
| Increments cur_implicit_order_index, keeps care of the wrap-around and invalidates the GUI.
void | IncrementRealOrderIndex ()
| Advanced cur_real_order_index to the next real order, keeps care of the wrap-around and invalidates the GUI.
void | UpdateRealOrderIndex ()
| Skip implicit orders until cur_real_order_index is a non-implicit order.
Order * | GetOrder (int index) const
| Returns order 'index' of a vehicle or NULL when it doesn't exists.
Order * | GetLastOrder () const
| Returns the last order of a vehicle, or NULL if it doesn't exists.
bool | IsEngineCountable () const
| Check if a vehicle is counted in num_engines in each company struct.
bool | HasEngineType () const
| Check whether Vehicle::engine_type has any meaning.
bool | HasDepotOrder () const
| Checks if a vehicle has a depot in its order list.
void | HandlePathfindingResult (bool path_found)
| Handle the pathfinding result, especially the lost status.
bool | IsFrontEngine () const
| Check if the vehicle is a front engine.
bool | IsArticulatedPart () const
| Check if the vehicle is an articulated part of an engine.
bool | HasArticulatedPart () const
| Check if an engine has an articulated part.
Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >
void * | operator new (size_t size)
| Allocates space for new Titem.
void * | operator new (size_t size, size_t index)
| Allocates space for new Titem with given index.
void * | operator new (size_t size, void *ptr)
| Allocates space for new Titem at given memory address.
void | operator delete (void *p)
| Marks Titem as free.
Public Member Functions inherited from BaseConsist
void | CopyConsistPropertiesFrom (const BaseConsist *src)
| Copy properties of other BaseConsist.

## Data Fields
TrackBitsByte | state
| The "track" the ship is following.

## Additional Inherited Members
Public Types inherited from SpecializedVehicle< Ship, VEH_SHIP >
typedef SpecializedVehicle < Ship, Type > | SpecializedVehicleBase
| Our type.
Static Public Member Functions inherited from SpecializedVehicle< Ship, VEH_SHIP >
static bool | IsValidID (size_t index)
| Tests whether given index is a valid index for vehicle of this type.
static Ship * | Get (size_t index)
| Gets vehicle with given index.
static Ship * | GetIfValid (size_t index)
| Returns vehicle if the index is a valid index for this vehicle type.
static Ship * | From (Vehicle *v)
| Converts a Vehicle to SpecializedVehicle with type checking.
static const Ship * | From (const Vehicle *v)
| Converts a const Vehicle to const SpecializedVehicle with type checking.
Static Public Attributes inherited from SpecializedVehicle< Ship, VEH_SHIP >
static const VehicleType | EXPECTED_TYPE
| Specialized type.

## Detailed Description

All ships have this type.

Definition at line 24 of file ship.h.

## Constructor & Destructor Documentation

virtual Ship::~Ship | ( |  | ) |
| inlinevirtual

We want to 'destruct' the right class.

Definition at line 30 of file ship.h.

References Vehicle::PreDestructor().

## Member Function Documentation

bool Ship::FindClosestDepot | ( | TileIndex * | location,
|  | DestinationID * | destination,
|  | bool * | reverse
| ) |  |
| virtual

Find the closest depot for this vehicle and tell us the location, DestinationID and whether we should reverse.

Parameters

  location | where do we go to?
  destination | what hangar do we go to?
  reverse | should the vehicle be reversed?

Returns
  true if a depot could be found.

Reimplemented from Vehicle.

Definition at line 713 of file ship_cmd.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index.

int Ship::GetCurrentMaxSpeed | ( |  | ) | const
| inlinevirtual

Calculates the maximum speed of the vehicle under its current conditions.

Returns
  Current maximum speed in native units.

Reimplemented from Vehicle.

Definition at line 40 of file ship.h.

References VehicleCache::cached_max_speed, min(), and Vehicle::vcache.

int Ship::GetDisplayMaxSpeed | ( |  | ) | const
| inlinevirtual

Gets the maximum speed in km-ish/h that can be sent into SetDParam for string processing.

Returns
  the vehicle's maximum speed

Reimplemented from Vehicle.

Definition at line 39 of file ship.h.

References VehicleCache::cached_max_speed, and Vehicle::vcache.

int Ship::GetDisplaySpeed | ( |  | ) | const
| inlinevirtual

Gets the speed in km-ish/h that can be sent into SetDParam for string processing.

Returns
  the vehicle's speed

Reimplemented from Vehicle.

Definition at line 38 of file ship.h.

References Vehicle::cur_speed.

ExpensesType Ship::GetExpenseType | ( | bool | income | ) | const
| inlinevirtual

Sets the expense type associated to this vehicle type.

Parameters

  income | whether this is income or (running) expenses of the vehicle

Reimplemented from Vehicle.

Definition at line 34 of file ship.h.

References EXPENSES_SHIP_INC, and EXPENSES_SHIP_RUN.

void Ship::GetImage | ( | Direction | direction,
|  | EngineImageType | image_type,
|  | VehicleSpriteSeq * | result
| ) |  | const
| virtual

Gets the sprite to show for the given direction.

Parameters

  | direction | the direction the vehicle is facing
  [out] | result | Vehicle sprite sequence.

Reimplemented from Vehicle.

Definition at line 126 of file ship_cmd.cpp.

References Vehicle::GetEngine(), VehicleSpriteSeq::IsValid(), Engine::original_image_index, VehicleSpriteSeq::Set(), and Vehicle::spritenum.

TileIndex Ship::GetOrderStationLocation | ( | StationID | station | ) |
| virtual

Determine the location for the station where the vehicle goes to next.

Things done for example are allocating slots in a road stop or exact location of the platform is determined for ships.

Parameters

  station | the station to make the next location of the vehicle.

Returns
  the location (tile) to aim for.

Reimplemented from Vehicle.

Definition at line 285 of file ship_cmd.cpp.

References Station::dock_tile, SpecializedVehicle< Ship, VEH_SHIP >::Get(), GetDockOffset(), Vehicle::IncrementRealOrderIndex(), INVALID_TILE, Vehicle::last_station_visited, TILE_ADD, and ToTileIndexDiff().

Money Ship::GetRunningCost | ( |  | ) | const
| virtual

Gets the running cost of a vehicle.

Returns
  the vehicle's running cost

Reimplemented from Vehicle.

Definition at line 216 of file ship_cmd.cpp.

References Vehicle::GetEngine(), Engine::GetGRF(), GetPrice(), and PROP_SHIP_RUNNING_COST_FACTOR.

Referenced by OnNewDay().

Trackdir Ship::GetVehicleTrackdir | ( |  | ) | const
| virtual

Returns the Trackdir on which the vehicle is currently located.

Works for trains and ships. Currently works only sortof for road vehicles, since they have a fuzzy concept of being "on" a trackdir. Dunno really what it returns for a road vehicle that is halfway a tile, never really understood that part. For road vehicles that are at the beginning or end of the tile, should just return the diagonal trackdir on which they are driving. I think. For other vehicles types, or vehicles with no clear trackdir (such as those in depots), returns 0xFF.

Returns
  the trackdir of the vehicle

Reimplemented from Vehicle.

Definition at line 249 of file ship_cmd.cpp.

References DiagDirToDiagTrackdir(), Vehicle::direction, DirToDiagDir(), FindFirstTrack(), GetShipDepotDirection(), INVALID_TRACKDIR, IsInDepot(), state, TRACK_BIT_WORMHOLE, TrackDirectionToTrackdir(), Vehicle::vehstatus, and VS_CRASHED.

Referenced by NPFShipCheckReverse(), NPFShipChooseTrack(), OPFShipChooseTrack(), and YapfShipCheckReverse().

bool Ship::IsInDepot | ( |  | ) | const
| inlinevirtual

Check whether the vehicle is in the depot.

Returns
  true if and only if the vehicle is in the depot.

Reimplemented from Vehicle.

Definition at line 42 of file ship.h.

References state, and TRACK_BIT_DEPOT.

Referenced by GetVehicleTrackdir().

void Ship::MarkDirty | ( |  | ) |
| virtual

Marks the vehicles to be redrawn and updates cached variables.

This method marks the area of the vehicle on the screen as dirty. It can be use to repaint the vehicle.

Reimplemented from Vehicle.

Definition at line 266 of file ship_cmd.cpp.

References Vehicle::colourmap, UpdateCache(), and SpecializedVehicle< Ship, VEH_SHIP >::UpdateViewport().

bool Ship::Tick | ( |  | ) |
| virtual

Calls the tick handler of the vehicle.

Returns
  is this vehicle still valid?

Reimplemented from Vehicle.

Definition at line 633 of file ship_cmd.cpp.

References Vehicle::running_ticks, Vehicle::vehstatus, and VS_STOPPED.

void Ship::UpdateDeltaXY | ( | Direction | direction | ) |
| virtual

Updates the x and y offsets and the size of the sprite used for this vehicle.

Parameters

  direction | the direction the vehicle is facing

Reimplemented from Vehicle.

Definition at line 298 of file ship_cmd.cpp.

References Vehicle::direction, Vehicle::x_extent, Vehicle::x_offs, Vehicle::y_extent, Vehicle::y_offs, and Vehicle::z_extent.

Referenced by CmdBuildShip().

The documentation for this struct was generated from the following files:

- src/ship.h
- src/ship_cmd.cpp